org.vishia.gral.swt

## Class SwtMng

- java.lang.Object
- - org.vishia.gral.base.GralMng.ImplAccess
  - - org.vishia.gral.swt.SwtMng

-     public class SwtMng
      extends GralMng.ImplAccess

  This class manages the building of Panels with GUI-Elements for example for a Dialog Box The container can be visibilized as a part of another container of any window. An example is given in `mainGuiSwt.SampleGuiSwtButtonInput`
  The positions on the display are based on grid units. The grid-size (number of x- and y-pixel per grid unit) is able to set, so a more large or a more small representation of the graphic is shown, depending on the display point size, the distance to view or personal defaults.
  A layout manager like flow-layout is not used here. The user sets fix positions in the grid units. A grid unit is a half-small-line in the vertical direction and about a small character width in the x-direction. So a closed-to-user-thinking position is able to set for any component. It is like rows or lines and columns. An automatically layout managing using self-deciding positioning of any components is not done. But a next added component may be positioned right from the previous or below the previous without manually calculation and setting of the position. It simplifies positioning.
  This class supports setting of values of shown components with symbolic access (String-name) in runtime and selecting of button-actions and data-container while creating with symbolic access to the action-instance or the data-container. This property is used especially by the text-script-controlled built of a dialog widget using the `GralCfgBuilder`, but it is able to simplify the access to data and actions elsewhere too.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `SwtMng.NotExistException` The GUI may be determined by a external user file.
    `(package private) static class` | `SwtMng.SelectionListenerForSlider`
    `protected class` | `SwtMng.SwtMngFocusListener` Universal focus listener to register which widgets were in focus in its order, to set htmlHelp and to invoke the `GralWidget.setActionFocused(GralUserAction)`.
    `protected class` | `SwtMng.SwtMngMouseMenuListener` Universal context menu listener
    `private static class` | `SwtMng.TestHelp` This class is only used to store values to inspect.
    `protected class` | `SwtMng.XXXButtonUserAction` Action for user commands of buttons.
    `protected static interface` | `SwtMng.XXXUserAction` It is a marker interface.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) org.eclipse.swt.widgets.Display` | `displaySwt`
    `protected SwtMng.SwtMngFocusListener` | `focusListener` The package private universal focus listener.
    `(package private) org.eclipse.swt.events.MouseListener` | `mouseClickForInfo` Deprecated. use `SwtGralMouseListener.mouseActionStd`, it is the same, but better structured.
    `(package private) SwtMng.SwtMngMouseMenuListener` | `mouseMenuListener` The package private universal focus listener.
    `SwtProperties` | `propertiesGuiSwt` Properties of this Dialog Window.
    `(package private) static SwtTraverseListener` | `swtTraverseListener` The instance for all traverse listener applicable to all widgets.
    `(package private) SwtMng.TestHelp` | `testHelp`
    `static java.lang.String` | `version` Version, history and license.
    `(package private) org.eclipse.swt.widgets.Listener` | `XXXX_mainKeyListener` This routine is invoked on any key event.
    `protected org.eclipse.swt.graphics.Rectangle` | `XXXXXcurrPanelPos` The graphical frame.

    - ### Fields inherited from class org.vishia.gral.base.GralMng.ImplAccess

      `mng`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SwtMng(org.eclipse.swt.widgets.Display display, char displaySize, LogMessage log)` Creates an instance.
    `` | `SwtMng(org.eclipse.swt.widgets.Display display, SwtProperties propertiesGui, LogMessage log)` Creates an instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `GralCurveView` | `addCurveViewY(java.lang.String sName, int nrofXvalues, GralCurveView.CommonCurve common)`
    `void` | `addFocusAction(GralWidget widgetInfo, GralUserAction action, java.lang.String sCmdEnter, java.lang.String sCmdRelease)`
    `GralWidget` | `addFocusAction(java.lang.String sName, GralUserAction action, java.lang.String sCmdEnter, java.lang.String sCmdRelease)`
    `GralHtmlBox` | `addHtmlBox(java.lang.String name)`
    `java.lang.Object` | `addImage(java.lang.String sName, java.io.InputStream imageStream, int height, int width, java.lang.String sCmd)`
    `GralWidget` | `addSlider(java.lang.String sName, GralUserAction action, java.lang.String sShowMethod, java.lang.String sDataPath)`
    `GralTabbedPanel` | `addTabbedPanel(java.lang.String namePanel, GralPanelActivated_ifc user, int property)` Adds a tab panel in implementation.
    `GralTable` | `addTable(java.lang.String sName, int height, int[] columnWidths)` Deprecated.
    `GralWidget` | `addText(java.lang.String sText, char size, int color)` Deprecated.
    `(package private) GralRectangle` | `calcPositionOfWindow(GralPos posWindow)` Calculates the position as absolute value on screen from a given position inside a panel.
    `GralRectangle` | `calcWidgetPosAndSize(GralPos pos, int widthwidgetNat, int heigthWidgetNat)` Calculates the bounds of a widget with a given pos independent of this `GralMng.ImplAccess.pos()`.
    `(package private) GralRectangle` | `calcWidgetPosAndSizeSwt(GralPos pos, org.eclipse.swt.widgets.Control parentComp, int widthwidgetNat, int heigthWidgetNat)` Calculates the bounds of a SWT component with a given position independent of `GralMng.ImplAccess.pos()`.
    `GralPanelContent` | `createCompositeBox(java.lang.String name)` Creates a box inside the current panel to hold some widgets.
    `protected GralMenu` | `createContextMenu(GralWidget widg)` Creates the context menu for the given widget for right-mouse pressing.
    `GralFileDialog_ifc` | `createFileDialog()`
    `GralPanelContent` | `createGridPanel(java.lang.String namePanel, GralColor backGround, int xG, int yG, int xS, int yS)` Creates an independent grid panel which is managed by this.
    `void` | `createImplWidget_Gthread(GralWidget widgg)`
    `protected GralMenu` | `createMenuBar(GralWindow windg)` Creates the menu bar for the given window.
    `void` | `createSubWindow(GralWindow windowGral)`
    `GralWindow` | `createWindow(java.lang.String name, java.lang.String title, int windProps)` Deprecated.
    `org.eclipse.swt.graphics.Color` | `getColorImpl(GralColor colorGral)` Gets the color of the graphic implementation (swt.Color, swing.TODO) Either the implementation color instance is stored already in the GralColor, or it will be created, stored in GralColor and returned here.
    `org.eclipse.swt.widgets.Composite` | `getCurrentPanel()` The composite of the panel in SWT.
    `private org.eclipse.swt.widgets.Composite` | `getCurrentPanel(GralWidget widgg)`
    `(package private) GralRectangle` | `getPixelUseableAreaOfWindow(GralWidget widgg)`
    `private java.lang.String` | `getValueFromTable(org.eclipse.swt.widgets.Table table)`
    `java.lang.String` | `getValueFromWidget(GralWidget widgd)` Deprecated.
    `org.eclipse.swt.widgets.Composite` | `getWidgetsPanel(GralWidget widg)`
    `void` | `redrawWidget(java.lang.String sName)` Forces the redrawing for all set samples.
    `boolean` | `remove(GralPanelContent compositeBox)`
    `void` | `resizeWidget(GralWidget widgd, int xSizeParent, int ySizeParent)` Forces the resizing of the given widged.
    `(package private) GralRectangle` | `setBounds_(GralPos pos, org.eclipse.swt.widgets.Control component)` Places a current component with knowledge of the current positions and the spreads of the component on graphic.
    `(package private) GralRectangle` | `setPosAndSize_(GralPos pos, org.eclipse.swt.widgets.Control component)`
    `(package private) GralRectangle` | `setPosAndSizeSwt(GralPos posP, org.eclipse.swt.widgets.Control component, int widthwidgetNat, int heigthWidgetNat)` Set bounds of a SWT component with a given position.
    `void` | `setSampleCurveViewY(java.lang.String sName, float[] values)` Adds a sampling value set.
    `boolean` | `showContextMenuGthread(GralWidget widg)` Shows the context menu of any widget independent of the internal right-mouse invocation.
    `(package private) void` | `stop()`
    `protected void` | `windowClosing()` This method can be override by the user to force some actions if the dialog window is closed.
    `protected GralMenu` | `XXXaddPopupMenu(java.lang.String sName)`
    `GralWidget` | `XXXaddTextField(GralWidget widgetInfo, boolean editable, java.lang.String prompt, char promptStylePosition)` Adds a text field for showing or editing a text value.
    `GralWidget` | `XXXaddTextField(java.lang.String name, boolean editable, java.lang.String prompt, char promptStylePosition)` Adds a text field for showing or editing a text value.
    `(package private) void` | `XXXsetPosAndSizeSwt(org.eclipse.swt.widgets.Control component, int widthwidgetNat, int heigthWidgetNat)` Set bounds of a SWT component with this `GralMng.pos()` from the GralWidgetMng.
    `boolean` | `XXXsetWindowsVisible(GralWindow_ifc window, GralPos atPos)` Sets a given and registered window visible at the given position and size or set it invisible.

    - ### Methods inherited from class org.vishia.gral.base.GralMng.ImplAccess

      `indexNameWidgets, listVisiblePanels_add, pos, sCurrPanel, userMainKeyAction`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### version

          public static final java.lang.String version

      Version, history and license. The version number is a date written as yyyymmdd as decimal number. Changes:
      - 2016-09-02 Hartmut chg: Some `GralPanelContent.GralPanelContent(String, String, char)` and `GralTabbedPanel.GralTabbedPanel(String, String, GralPanelActivated_ifc, int)` was invoked with "@" for the posString without any more posString information. That is false. The idea was: Set the current panel. But that does not run. See changes on `GralMng` on 2016-09-02.
      - 2013-12-21 Hartmut new: `createImplWidget_Gthread(GralWidget)` instanciates all widget types.
      - 2012-07-13 Hartmut chg: `resizeWidget(GralWidget, int, int)` can work with more as one widget implementation. But it isn't test and used yet. Size of any implementation widget?
      - 2012-03-17 Hartmut chg: some changes for `#setPosAndSizeSwt(Control, int, int)` etc.
      - 2012-01-26 Hartmut chg: prevent some error messages which are unnecessary.
      - 2012-01-01 Hartmut new: The `#setInfoGthread(GralWidget, int, int, Object, Object)` routine uses the `SwtSetValue_ifc` capability to associate cmd to types of widgets. Yet used only for `SwtSubWindow`.
      - 2011-12-03 Hartmut new: `#setInfoGthread(GralWidget, int, int, Object, Object)` catches any exception, before: An exception causes aborting the graphic thread.
      - 2011-12-03 Hartmut chg: `#addLed(String, String, String)` now uses `GralLed`.
      - 2011-12-03 Hartmut new: `#swtKeyListener` as base for all fields.
      - 2011-11-12 Hartmut chg: `calcPositionOfWindow(GralPos)` improved
      - 2011-08-13 Hartmut chg: New routines for store and calculate the position to regard large widgets.
      - 2011-06-17 Hartmut getValueFromWidget(): Table returns the whole selected line, cells separated with tab. The String-return.split("\t") separates the result to the cell values.
      - 2011-05-08 Hartmut new; `GralMng_ifc.cmdClear` used to clear a whole swt.Table, commonly using: clear a content of widget.
      - 2010-12-02 Hartmut: in method insertInfo((): call of checkAdmissibility() for some input parameter, elsewhere exceptions may be possible on evaluating the inserted info in doBeforeDispatching(). There the causer isn't found quickly while debugging.
      - 2010-12-02 Hartmut: Up to now this version variable, its description contains the version history.
      Copyright/Copyleft: For this source the LGPL Lesser General Public License, published by the Free Software Foundation is valid. It means:
      1. You can use this source without any restriction for any desired purpose.
      2. You can redistribute copies of this source to everybody.
      3. Every user of this source, also the user of redistribute copies with or without payment, must accept this license for further using.
      4. But the LPGL ist not appropriate for a whole software product, if this source is only a part of them. It means, the user must publish this part of source, but don't need to publish the whole source of the own product.
      5. You can study and modify (improve) this source for own using or for redistribution, but you have to license the modified sources likewise under this LGPL Lesser General Public License. You mustn't delete this Copyright/Copyleft inscription in this source file.
      If you are intent to use this sources without publishing its usage, you can get a second license subscribing a special contract with the author.
      See Also:
        Constant Field Values

    - #### XXXXXcurrPanelPos

          protected org.eclipse.swt.graphics.Rectangle XXXXXcurrPanelPos

      The graphical frame. It is any part of a window (a Composite widget) or the whole window.

    - #### propertiesGuiSwt

          public final SwtProperties propertiesGuiSwt

      Properties of this Dialog Window. The `GralMng` contains an aggregation to the same instance, but with type `GralGridProperties`. Internally there are some more Swt-capabilities in the derived type.

    - #### displaySwt

          final org.eclipse.swt.widgets.Display displaySwt

    - #### mouseClickForInfo

          @Deprecated
          org.eclipse.swt.events.MouseListener mouseClickForInfo

      Deprecated. use `SwtGralMouseListener.mouseActionStd`, it is the same, but better structured.
      This mouse-click-implementor is added to any widget, which is associated to a `GralWidget` in its data. The infos of the last clicked widget can be got with it.

    - #### swtTraverseListener

          static SwtTraverseListener swtTraverseListener

      The instance for all traverse listener applicable to all widgets.

    - #### testHelp

          SwtMng.TestHelp testHelp

    - #### XXXX_mainKeyListener

          org.eclipse.swt.widgets.Listener XXXX_mainKeyListener

      This routine is invoked on any key event. It is possible to change keys, to disable the event handling and to call special routines. Yet not used.

    - #### focusListener

          protected SwtMng.SwtMngFocusListener focusListener

      The package private universal focus listener.

    - #### mouseMenuListener

          SwtMng.SwtMngMouseMenuListener mouseMenuListener

      The package private universal focus listener.

  - ### Constructor Detail

    - #### SwtMng

          protected SwtMng(org.eclipse.swt.widgets.Display display,
                           char displaySize,
                           LogMessage log)

      Creates an instance.
      Parameters:
        `guiContainer` - The container where the elements are stored in.
        `width` - in display-units for the window's width, the number of pixel depends from param displaySize.
        `height` - in display-units for the window's height, the number of pixel depends from param displaySize.
        `displaySize` - character 'A' to 'E' to determine the size of the content (font size, pixel per cell). 'A' is the smallest, 'E' the largest size. Default: use 'C'.

    - #### SwtMng

          public SwtMng(org.eclipse.swt.widgets.Display display,
                        SwtProperties propertiesGui,
                        LogMessage log)

      Creates an instance.
      Parameters:
        `guiContainer` - The container where the elements are stored in.
        `width` - in display-units for the window's width, the number of pixel depends from param displaySize.
        `height` - in display-units for the window's height, the number of pixel depends from param displaySize.
        `displaySize` - character 'A' to 'E' to determine the size of the content (font size, pixel per cell). 'A' is the smallest, 'E' the largest size. Default: use 'C'.

  - ### Method Detail

    - #### getCurrentPanel

          public org.eclipse.swt.widgets.Composite getCurrentPanel()

      The composite of the panel in SWT.
      Specified by:
        `getCurrentPanel` in class `GralMng.ImplAccess`
      See Also:
        `GralMng.ImplAccess.getCurrentPanel()`

    - #### getWidgetsPanel

          public org.eclipse.swt.widgets.Composite getWidgetsPanel(GralWidget widg)

    - #### getCurrentPanel

          private org.eclipse.swt.widgets.Composite getCurrentPanel(GralWidget widgg)

    - #### createImplWidget_Gthread

          public void createImplWidget_Gthread(GralWidget widgg)

      Specified by:
        `createImplWidget_Gthread` in class `GralMng.ImplAccess`

    - #### createCompositeBox

          public GralPanelContent createCompositeBox(java.lang.String name)

      Description copied from class: `GralMng.ImplAccess`
      Creates a box inside the current panel to hold some widgets.
      Specified by:
        `createCompositeBox` in class `GralMng.ImplAccess`
      Returns:

    - #### createGridPanel

          public GralPanelContent createGridPanel(java.lang.String namePanel,
                                                  GralColor backGround,
                                                  int xG,
                                                  int yG,
                                                  int xS,
                                                  int yS)

      Description copied from class: `GralMng.ImplAccess`
      Creates an independent grid panel which is managed by this. The panel can be associated to any graphic frame.
      Specified by:
        `createGridPanel` in class `GralMng.ImplAccess`
      Returns:

    - #### remove

          public boolean remove(GralPanelContent compositeBox)

      Specified by:
        `remove` in class `GralMng.ImplAccess`

    - #### createWindow

          @Deprecated
          public GralWindow createWindow(java.lang.String name,
                                                      java.lang.String title,
                                                      int windProps)

      Deprecated.
      Specified by:
        `createWindow` in class `GralMng.ImplAccess`

    - #### createSubWindow

          public void createSubWindow(GralWindow windowGral)

      Specified by:
        `createSubWindow` in class `GralMng.ImplAccess`

    - #### XXXsetWindowsVisible

          public boolean XXXsetWindowsVisible(GralWindow_ifc window,
                                              GralPos atPos)

      Description copied from class: `GralMng.ImplAccess`
      Sets a given and registered window visible at the given position and size or set it invisible.
      A window can be created by invoking `org.vishia.gral.ifc.GralMngBuild_ifc#createWindow(String, boolean)` in the build phase of the gui. It can be hidden because it is not necessary to show and operate with them. In a adequate phase of operate it can be shown and focused.
      The position is given relative to that panel, which is stored in `GralPos.panel`. To get a position instance, you can set a position invoking
      - `GralMngBuild_ifc.selectPanel(String)`
      - `GralMngBuild_ifc.setPosition(float, float, float, float, int, char)`
      - GralGridPos pos = `GralMngBuild_ifc.getPositionInPanel()`.
      That can be done in the build phase of the graphic. The position can be stored. It is possible to adjust the position relative to the unchanged panel by changing the values of `GralPos.x` etc. It is possible too to change the Panel which relates to the position. Then the grid managing instance have to be known via the `GralMngBuild_ifc` to select a panel. The panels may be moved or resized. With the knowledge of the relative position of the window in respect to a panel of the parent window, the window can be placed onto a proper position of the whole display.
      Specified by:
        `XXXsetWindowsVisible` in class `GralMng.ImplAccess`
      Parameters:
        `window` - the instance of the window wrapper.
        `atPos` - If null then hide the window. If not null then show the window. The position and size of the window is given related to any panel of any other window.
      Returns:
        true if it is visible.

    - #### calcPositionOfWindow

          GralRectangle calcPositionOfWindow(GralPos posWindow)

      Calculates the position as absolute value on screen from a given position inside a panel.
      Parameters:
        `posWindow` - contains any `GralPos.panel`. Its absolute position will be determined. from that position and size the absolute postion will be calculate, with this given grid positions inside the panel.
      Returns:
        Absolute pixel coordinate.

    - #### getPixelUseableAreaOfWindow

          GralRectangle getPixelUseableAreaOfWindow(GralWidget widgg)

    - #### windowClosing

          protected void windowClosing()

      This method can be override by the user to force some actions if the dialog window is closed. It may be left empty.

    - #### setBounds_

          GralRectangle setBounds_(GralPos pos,
                                   org.eclipse.swt.widgets.Control component)

      Places a current component with knowledge of the current positions and the spreads of the component on graphic.
      Parameters:
        `component` - The component to place.

    - #### setPosAndSize_

          GralRectangle setPosAndSize_(GralPos pos,
                                       org.eclipse.swt.widgets.Control component)

    - #### XXXsetPosAndSizeSwt

          void XXXsetPosAndSizeSwt(org.eclipse.swt.widgets.Control component,
                                   int widthwidgetNat,
                                   int heigthWidgetNat)

      Set bounds of a SWT component with this `GralMng.pos()` from the GralWidgetMng. The `GralMng.setNextPosition()` is called to process a used this.pos to its next. This method is package-private for SWT-implementation. It calls `GralMng.setNextPosition()` and `setPosAndSizeSwt(GralPos, Control, int, int)` with
      Parameters:
        `component` - The SWT-widget.
        `widthwidgetNat` - The natural size of the component.
        `heigthWidgetNat` - The natural size of the component. NOTE: 2015-07-13: This method is set to unused because it uses the mng-position additional to the constructor of GralWidget. This is the old concept which is in conflict with the usuage there.

    - #### setPosAndSizeSwt

          GralRectangle setPosAndSizeSwt(GralPos posP,
                                         org.eclipse.swt.widgets.Control component,
                                         int widthwidgetNat,
                                         int heigthWidgetNat)

      Set bounds of a SWT component with a given position. This method is package-private for SWT-implementation.
      Parameters:
        `posP` - The Position for the component.
        `component` - The SWT-widget.
        `widthwidgetNat` - The natural size of the component.
        `heigthWidgetNat` - The natural size of the component.

    - #### calcWidgetPosAndSize

          public GralRectangle calcWidgetPosAndSize(GralPos pos,
                                                    int widthwidgetNat,
                                                    int heigthWidgetNat)

      Calculates the bounds of a widget with a given pos independent of this `GralMng.ImplAccess.pos()`. This method is a part of the implementing GralMng because the GralPos is not implemented for any underlying graphic system and the `propertiesGuiSwt` are used. It is possible to tune the bounds after calculation, for example to enhance the width if a text is larger then the intended position.
      Specified by:
        `calcWidgetPosAndSize` in class `GralMng.ImplAccess`
      Parameters:
        `pos` - The position.
        `widthwidgetNat` - The natural size of the component.
        `heigthWidgetNat` - The natural size of the component.
      Returns:
        A rectangle with position and size.

    - #### calcWidgetPosAndSizeSwt

          GralRectangle calcWidgetPosAndSizeSwt(GralPos pos,
                                                org.eclipse.swt.widgets.Control parentComp,
                                                int widthwidgetNat,
                                                int heigthWidgetNat)

      Calculates the bounds of a SWT component with a given position independent of `GralMng.ImplAccess.pos()`. This method is package-private for SWT-implementation. It is possible to tune the bounds after calculation, for example to enhance the width if a text is larger then the intended position.
      Parameters:
        `pos` - The position.
        `component` - The SWT-widget.
        `widthwidgetNat` - The natural size of the component.
        `heigthWidgetNat` - The natural size of the component.
      Returns:
        A rectangle with position and size.

    - #### addTabbedPanel

          public GralTabbedPanel addTabbedPanel(java.lang.String namePanel,
                                                GralPanelActivated_ifc user,
                                                int property)

      Adds a tab panel in implementation. If this routine was called, the GralMng.pos is the pos for the Tabbed panel.
      Specified by:
        `addTabbedPanel` in class `GralMng.ImplAccess`
      See Also:
        `GralMng.ImplAccess.addTabbedPanel(java.lang.String, org.vishia.gral.base.GralPanelActivated_ifc, int)`

    - #### addText

          @Deprecated
          public GralWidget addText(java.lang.String sText,
                                                 char size,
                                                 int color)

      Deprecated.
      Specified by:
        `addText` in class `GralMng.ImplAccess`

    - #### XXXaddTextField

          public GralWidget XXXaddTextField(java.lang.String name,
                                            boolean editable,
                                            java.lang.String prompt,
                                            char promptStylePosition)

      Adds a text field for showing or editing a text value.
      Parameters:
        `sName` - The registering name
        `width` - Number of grid units for length
        `editable` - true than edit-able, false to show content
        `prompt` - If not null, than a description label is shown
        `promptStylePosition` - Position and size of description label: upper case letter: normal font, lower case letter: small font 'l' left, 't' top (above field)
      Returns:

    - #### XXXaddTextField

          public GralWidget XXXaddTextField(GralWidget widgetInfo,
                                            boolean editable,
                                            java.lang.String prompt,
                                            char promptStylePosition)

      Adds a text field for showing or editing a text value.
      Parameters:
        `sName` - The registering name
        `width` - Number of grid units for length
        `editable` - true than edit-able, false to show content
        `prompt` - If not null, than a description label is shown
        `promptStylePosition` - Position and size of description label: upper case letter: normal font, lower case letter: small font 'l' left, 't' top (above field)
      Returns:

    - #### addHtmlBox

          public GralHtmlBox addHtmlBox(java.lang.String name)

      Specified by:
        `addHtmlBox` in class `GralMng.ImplAccess`

    - #### addImage

          public java.lang.Object addImage(java.lang.String sName,
                                           java.io.InputStream imageStream,
                                           int height,
                                           int width,
                                           java.lang.String sCmd)

      Specified by:
        `addImage` in class `GralMng.ImplAccess`

    - #### addSlider

          public GralWidget addSlider(java.lang.String sName,
                                      GralUserAction action,
                                      java.lang.String sShowMethod,
                                      java.lang.String sDataPath)

      Specified by:
        `addSlider` in class `GralMng.ImplAccess`

    - #### addCurveViewY

          public GralCurveView addCurveViewY(java.lang.String sName,
                                             int nrofXvalues,
                                             GralCurveView.CommonCurve common)

      Specified by:
        `addCurveViewY` in class `GralMng.ImplAccess`

    - #### addFocusAction

          public GralWidget addFocusAction(java.lang.String sName,
                                           GralUserAction action,
                                           java.lang.String sCmdEnter,
                                           java.lang.String sCmdRelease)

      Specified by:
        `addFocusAction` in class `GralMng.ImplAccess`

    - #### addFocusAction

          public void addFocusAction(GralWidget widgetInfo,
                                     GralUserAction action,
                                     java.lang.String sCmdEnter,
                                     java.lang.String sCmdRelease)

      Specified by:
        `addFocusAction` in class `GralMng.ImplAccess`

    - #### addTable

          @Deprecated
          public GralTable addTable(java.lang.String sName,
                                                 int height,
                                                 int[] columnWidths)

      Deprecated.
      Specified by:
        `addTable` in class `GralMng.ImplAccess`

    - #### XXXaddPopupMenu

          protected GralMenu XXXaddPopupMenu(java.lang.String sName)

      Specified by:
        `XXXaddPopupMenu` in class `GralMng.ImplAccess`

    - #### createContextMenu

          protected GralMenu createContextMenu(GralWidget widg)

      Description copied from class: `GralMng.ImplAccess`
      Creates the context menu for the given widget for right-mouse pressing. This method is invoked only in `GralWidget.getContextMenu()` whereby an existing context menu is stored in the `GralWidget.contextMenu` association. The widget have to be set to panel already, an implementation widget have to be existing. It means `GralWidget#getWidgetImplementation()` should be return that instance where the menu is to be added. This method is package protected because it should only be called internally.
      Specified by:
        `createContextMenu` in class `GralMng.ImplAccess`

    - #### createMenuBar

          protected GralMenu createMenuBar(GralWindow windg)

      Description copied from class: `GralMng.ImplAccess`
      Creates the menu bar for the given window. This method is invoked only in `GralWindow.getMenuBar()` whereby an existing menu bar is stored in the `GralWindow.menuBarGral` association.
      Specified by:
        `createMenuBar` in class `GralMng.ImplAccess`
      Parameters:
        `windg` - The window

    - #### createFileDialog

          public GralFileDialog_ifc createFileDialog()

      Specified by:
        `createFileDialog` in class `GralMng.ImplAccess`

    - #### setSampleCurveViewY

          public void setSampleCurveViewY(java.lang.String sName,
                                          float[] values)

      Description copied from class: `GralMng.ImplAccess`
      Adds a sampling value set.
      Specified by:
        `setSampleCurveViewY` in class `GralMng.ImplAccess`
      Parameters:
        `sName` - The registered name
        `values` - The values.

    - #### redrawWidget

          public void redrawWidget(java.lang.String sName)

      Description copied from class: `GralMng.ImplAccess`
      Forces the redrawing for all set samples. It should be called after { @link #setSampleCurveViewY(String, float[])}.
      Specified by:
        `redrawWidget` in class `GralMng.ImplAccess`
      Parameters:
        `sName` - The name of the widget.

    - #### resizeWidget

          public void resizeWidget(GralWidget widgd,
                                   int xSizeParent,
                                   int ySizeParent)

      Description copied from class: `GralMng.ImplAccess`
      Forces the resizing of the given widged.
      Specified by:
        `resizeWidget` in class `GralMng.ImplAccess`
      Parameters:
        `widgd` - the widget

    - #### getValueFromWidget

          @Deprecated
          public java.lang.String getValueFromWidget(GralWidget widgd)

      Deprecated.
      Specified by:
        `getValueFromWidget` in class `GralMng.ImplAccess`

    - #### getValueFromTable

          private java.lang.String getValueFromTable(org.eclipse.swt.widgets.Table table)

    - #### getColorImpl

          public org.eclipse.swt.graphics.Color getColorImpl(GralColor colorGral)

      Description copied from class: `GralMng.ImplAccess`
      Gets the color of the graphic implementation (swt.Color, swing.TODO) Either the implementation color instance is stored already in the GralColor, or it will be created, stored in GralColor and returned here.
      Specified by:
        `getColorImpl` in class `GralMng.ImplAccess`
      Parameters:
        `colorGral` - The Color.
      Returns:
        Instance of the implementation color.

    - #### showContextMenuGthread

          public boolean showContextMenuGthread(GralWidget widg)

      Description copied from class: `GralMng.ImplAccess`
      Shows the context menu of any widget independent of the internal right-mouse invocation.
      Specified by:
        `showContextMenuGthread` in class `GralMng.ImplAccess`
      Parameters:
        `widg` - The widget.
      Returns:
        true if the widget have a context menu.

    - #### stop

          void stop()